<template>
  <!-- Value -->
  <template v-if="value">
    <td :class="cellClass" class="_gpa-harvest-variation__value">{{ pair.value.toFixed(2) }}</td>
    <td :class="cellClass" class="_gpa-harvest-variation__unit">{{ unitsSymbols[pair.unit] }}</td>
  </template>
  <template v-else>
    <td :class="cellClass" class="_gpa-harvest-variation__value text--color-mute">&mdash;</td>
    <td :class="cellClass" class="_gpa-harvest-variation__unit text--color-mute">&mdash;</td>
  </template>

  <!-- Variation -->
  <template v-if="delta !== 0">
    <td :class="[cellClass, deltaCSS]" class="_gpa-harvest-variation__delta-value">
      {{ deltaSymbol }}{{ deltaPair.value.toFixed(2) }}
    </td>
    <td :class="[cellClass, deltaCSS]" class="_gpa-harvest-variation__delta-unit">
      {{ unitsSymbols[deltaPair.unit] }}
    </td>
  </template>
  <template v-else>
    <td :class="cellClass" class="_gpa-harvest-variation__delta-value text--color-mute">&mdash;</td>
    <td :class="cellClass" class="_gpa-harvest-variation__delta-unit text--color-mute">&mdash;</td>
  </template>
</template>

<script>
import { convertUnit, unitsSymbols } from '@/helpers/Units'

export default {
  name: 'GpaHarvestVariation',
  props: {
    value: { required: false, type: Number, default: 0 },
    previous: { required: false, type: Number, default: 0 },
    unit: { required: true, type: String },
    cellClass: { required: false, type: String, default: null },
  },
  data () {
    return {
      unitsSymbols,
    }
  },
  computed: {
    /** @returns {object} Converted delta value/unit pair */
    deltaPair () { return convertUnit(this.delta, this.unit) },
    /** @returns {object} Converted value/unit pair */
    pair () { return convertUnit(this.value, this.unit) },
    /** @returns {number} Computed amount */
    delta () { return this.value - this.previous },
    /** @returns {string} Symbol to display */
    deltaSymbol () {
      return this.delta > 0 ? '+' : ''
    },
    deltaCSS () {
      if (this.delta === 0) return ''

      return this.delta > 0 ? 'text--color-success' : 'text--color-danger'
    },
  },
}
</script>

<style lang="scss" src="./_Variation.scss" />
